package brn.gui.commands;

/**
 * Interface defining the application's command IDs.
 * Key bindings can be defined for specific commands.
 * To associate an action with a command, use IAction.setActionDefinitionId(commandId).
 *
 * @see org.eclipse.jface.action.IAction#setActionDefinitionId(String)
 */
public interface ICommandIds {

    public static final String CMD_OPEN = "brn.gui.openconfig";

	public static final String CMD_LISTEN_SIM = "brn.gui.listensim";

	public static final String CMD_UNLISTEN_SIM = "brn.gui.unlistensim";

	public static final String CMD_DEBUG_SIM = "brn.gui.debugsim";

	public static final String CMD_RUN_SIM = "brn.gui.runsim";

	public static final String CMD_PAUSE_SIM = "brn.gui.pausesim";

	public static final String CMD_STOP_SIM = "brn.gui.stopsim";

  public static final String CMD_OPEN_DATA = "brn.gui.opendata";

  public static final String CMD_OPEN_OUTLINE = "brn.gui.opendata";

  public static final String CMD_LAYOUT_SIMULATION_PLACEMENT = "brn.gui.layoutSimulation";

  public static final String CMD_OPEN_DB_BROWSER = "brn.gui.openDatabaseBrowser";

}
