package test.sim.scenario;

import brn.sim.AbstractDriver;
import brn.sim.AbstractParams;
import brn.sim.handler.TimeBarRadioChannelHandler;
import brn.sim.handler.LinkQualityHandler;
import brn.sim.builder.*;
import brn.sim.scenario.mchannel.McExORParams;
import brn.swans.app.UdpApplication;
import org.apache.log4j.Logger;
import test.sim.handler.McExORTestEventHandler;
import jist.swans.Node;
import jist.swans.trans.AbstractTrans;

/**
 * Tests multi-channel McExOR with RTS/CTS.
 */
public class TestMChwRCtsSim extends AbstractTestMcExOR {

  public static void main(String[] args) {
    TestMChwRCtsSim test = new TestMChwRCtsSim();

    try {
      int seed = 106;

      System.out.println("TestMChwRCtsSim called with seed " + seed);
      McExORParams options = McExORParams.withRtsCtsAndMultiChannel(seed, 2);
      //McExORParams options = McExORParams.maxThroughputParams();
      //McExORParams options = McExORParams.randomPlacementParams();

      //McExORParams options = McExORParams.defaultParamsOnGrid();

      test.run(options);
    } catch (Exception e) {
      throw new RuntimeException(e);
    }
  }
}
